\documentclass[10pt, letterpaper, conference]{IEEEtran}


% *** CITATION PACKAGES ***
%
%\usepackage{cite}
\usepackage[noadjust]{cite}
\renewcommand{\citedash}{--} 
% cite.sty was written by Donald Arseneau
% V1.6 and later of IEEEtran pre-defines the format of the cite.sty package
% \cite{} output to follow that of IEEE. Loading the cite package will
% result in citation numbers being automatically sorted and properly
% "compressed/ranged". e.g., [1], [9], [2], [7], [5], [6] without using
% cite.sty will become [1], [2], [5]--[7], [9] using cite.sty. cite.sty's
% \cite will automatically add leading space, if needed. Use cite.sty's
% noadjust option (cite.sty V3.8 and later) if you want to turn this off.
% cite.sty is already installed on most LaTeX systems. Be sure and use
% version 4.0 (2003-05-27) and later if using hyperref.sty. cite.sty does
% not currently provide for hyperlinked citations.
% The latest version can be obtained at:
% http://www.ctan.org/tex-archive/macros/latex/contrib/cite/
% The documentation is contained in the cite.sty file itself.


% *** GRAPHICS RELATED PACKAGES ***
%
\ifCLASSINFOpdf
  % \usepackage[pdftex]{graphicx}
  % declare the path(s) where your graphic files are
  % \graphicspath{{../pdf/}{../jpeg/}}
  % and their extensions so you won't have to specify these with
  % every instance of \includegraphics
  % \DeclareGraphicsExtensions{.pdf,.jpeg,.png}
\else
  % or other class option (dvipsone, dvipdf, if not using dvips). graphicx
  % will default to the driver specified in the system graphics.cfg if no
  % driver is specified.
  % \usepackage[dvips]{graphicx}
  % declare the path(s) where your graphic files are
  % \graphicspath{{../eps/}}
  % and their extensions so you won't have to specify these with
  % every instance of \includegraphics
  % \DeclareGraphicsExtensions{.eps}
\fi
% graphicx was written by David Carlisle and Sebastian Rahtz. It is
% required if you want graphics, photos, etc. graphicx.sty is already
% installed on most LaTeX systems. The latest version and documentation can
% be obtained at: 
% http://www.ctan.org/tex-archive/macros/latex/required/graphics/
% Another good source of documentation is "Using Imported Graphics in
% LaTeX2e" by Keith Reckdahl which can be found as epslatex.ps or
% epslatex.pdf at: http://www.ctan.org/tex-archive/info/
%
% latex, and pdflatex in dvi mode, support graphics in encapsulated
% postscript (.eps) format. pdflatex in pdf mode supports graphics
% in .pdf, .jpeg, .png and .mps (metapost) formats. Users should ensure
% that all non-photo figures use a vector format (.eps, .pdf, .mps) and
% not a bitmapped formats (.jpeg, .png). IEEE frowns on bitmapped formats
% which can result in "jaggedy"/blurry rendering of lines and letters as
% well as large increases in file sizes.
%
% You can find documentation about the pdfTeX application at:
% http://www.tug.org/applications/pdftex


% *** ALIGNMENT PACKAGES ***
%
%\usepackage{array}
% Frank Mittelbach's and David Carlisle's array.sty patches and improves
% the standard LaTeX2e array and tabular environments to provide better
% appearance and additional user controls. As the default LaTeX2e table
% generation code is lacking to the point of almost being broken with
% respect to the quality of the end results, all users are strongly
% advised to use an enhanced (at the very least that provided by array.sty)
% set of table tools. array.sty is already installed on most systems. The
% latest version and documentation can be obtained at:
% http://www.ctan.org/tex-archive/macros/latex/required/tools/


% *** SUBFIGURE PACKAGES ***
%\usepackage[tight,footnotesize]{subfigure}
% subfigure.sty was written by Steven Douglas Cochran. This package makes it
% easy to put subfigures in your figures. e.g., "Figure 1a and 1b". For IEEE
% work, it is a good idea to load it with the tight package option to reduce
% the amount of white space around the subfigures. subfigure.sty is already
% installed on most LaTeX systems. The latest version and documentation can
% be obtained at:
% http://www.ctan.org/tex-archive/obsolete/macros/latex/contrib/subfigure/
% subfigure.sty has been superceeded by subfig.sty.


%\usepackage[caption=false]{caption}
%\usepackage[font=footnotesize]{subfig}
% subfig.sty, also written by Steven Douglas Cochran, is the modern
% replacement for subfigure.sty. However, subfig.sty requires and
% automatically loads Axel Sommerfeldt's caption.sty which will override
% IEEEtran.cls handling of captions and this will result in nonIEEE style
% figure/table captions. To prevent this problem, be sure and preload
% caption.sty with its "caption=false" package option. This is will preserve
% IEEEtran.cls handing of captions. Version 1.3 (2005/06/28) and later 
% (recommended due to many improvements over 1.2) of subfig.sty supports
% the caption=false option directly:
%\usepackage[caption=false,font=footnotesize]{subfig}
%
% The latest version and documentation can be obtained at:
% http://www.ctan.org/tex-archive/macros/latex/contrib/subfig/
% The latest version and documentation of caption.sty can be obtained at:
% http://www.ctan.org/tex-archive/macros/latex/contrib/caption/


% *** FLOAT PACKAGES ***
%
%\usepackage{fixltx2e}
% fixltx2e, the successor to the earlier fix2col.sty, was written by
% Frank Mittelbach and David Carlisle. This package corrects a few problems
% in the LaTeX2e kernel, the most notable of which is that in current
% LaTeX2e releases, the ordering of single and double column floats is not
% guaranteed to be preserved. Thus, an unpatched LaTeX2e can allow a
% single column figure to be placed prior to an earlier double column
% figure. The latest version and documentation can be found at:
% http://www.ctan.org/tex-archive/macros/latex/base/


%\usepackage{stfloats}
% stfloats.sty was written by Sigitas Tolusis. This package gives LaTeX2e
% the ability to do double column floats at the bottom of the page as well
% as the top. (e.g., "\begin{figure*}[!b]" is not normally possible in
% LaTeX2e). It also provides a command:
%\fnbelowfloat
% to enable the placement of footnotes below bottom floats (the standard
% LaTeX2e kernel puts them above bottom floats). This is an invasive package
% which rewrites many portions of the LaTeX2e float routines. It may not work
% with other packages that modify the LaTeX2e float routines. The latest
% version and documentation can be obtained at:
% http://www.ctan.org/tex-archive/macros/latex/contrib/sttools/
% Documentation is contained in the stfloats.sty comments as well as in the
% presfull.pdf file. Do not use the stfloats baselinefloat ability as IEEE
% does not allow \baselineskip to stretch. Authors submitting work to the
% IEEE should note that IEEE rarely uses double column equations and
% that authors should try to avoid such use. Do not be tempted to use the
% cuted.sty or midfloat.sty packages (also by Sigitas Tolusis) as IEEE does
% not format its papers in such ways.


% *** PDF, URL AND HYPERLINK PACKAGES ***
%
\usepackage{url}
% url.sty was written by Donald Arseneau. It provides better support for
% handling and breaking URLs. url.sty is already installed on most LaTeX
% systems. The latest version can be obtained at:
% http://www.ctan.org/tex-archive/macros/latex/contrib/misc/
% Read the url.sty source comments for usage information. Basically,
% \url{my_url_here}.

\usepackage{tikz}
\usetikzlibrary{arrows.meta,
  positioning,
  babel
}

\input{macros}

\begin{document}

%--------------------------------- TITLE ------------------------------------ %
% paper title
% can use linebreaks \\ within to get better formatting as desired
\title{Designing a machine learning framework for on-road license plate
	decodification suited to NVIDIA Jetson systems}

%--------------------------------- AUTHORS ---------------------------------- %

\author{
	\IEEEauthorblockN{Luis G. Le\'on-Vega\tec, Emmanuel Madrigal Cerdas\tec}
	\vspace{3pt}
	%
	\IEEEauthorblockA{
		\begin{tabular}{c}
			{\tec} Instituto Tecnol\'ogico de Costa Rica (TEC), Costa Rica \\
		\end{tabular}
	}
	%
	\vspace{3pt}
	\IEEEauthorblockA{
		\begin{tabular}{ccc}
			\{lleon95, emmadrigal\}@estudiantec.cr
		\end{tabular}
	}
	%\vspace{50pt}
	\vspace{-18pt}
}

% use for special paper notices
%\IEEEspecialpapernotice{(Invited Paper)}

% make the title area
\maketitle

%
%/Applications/texstudio.app/Contents/Resources
%/Volumes/texstudio/texstudio.app/Contents/Resources

%--------------------------------- ABSTRACT ---------------------------------- %
\begin{abstract}
	This paper proposes a machine learning (ML) framework for on-road
	license plate decodification by using state-of-the-art techniques
	combined with classical computer vision (CV) techniques. The
	framework is based on PyTorch and OpenCV as back-ends for ML and
	CV. The ML structure is composed by license plate detection and
	character classification, with networks inspired from YOLO and LeNet
	architectures. The complete system can run at $2\ fps$,
	which is enough for some applications such as traffic tolling, and
	car parking. The detection reaches a mAP of $72\%$ and the character
	classification reaches an $98.5\%$ accuracy.
\end{abstract}

% Keywords based on IEEE taxonomy: 
%https://www.ieee.org/content/dam/ieee-org/ieee/web/org/pubs/taxonomy_v101.pdf
\begin{IEEEkeywords}
	Computer vision, Object detection, Multi-layer neural network, Image
	classification
\end{IEEEkeywords}

%------------------------------- INTRODUCTION --------------------------------%
\section{Introduction}
\label{sec:introduction}

Collecting money from traffic tolls is a common practice among
countries in the world to fund public infrastructure such as highways,
streets, public illumination, and others. At global scale, traffic
tolling market worth around 7-billion
dollars~\cite{Chattopadhyay}. The infrastructure required to set up
the devices is multi-tiered and expensive.

All-electronic traffic tools rely on either RFID-based technologies or
license plate detection. The first approach involves installing an
on-board device which is powered wirelessly by the toll system and
emits its ID to the collecting system over the
road~\cite{RFID_Tolls}. This approach often involves the user to get a
new device, which can be paid one time or rented. Usually, users link
the devices to their bank account or to a pre-paid account,
transferring funds according to their needs.

The license plate detection methods rely on Computer Vision techniques
and on-road cameras to retrieve photos from the license plates, where
an algorithm extracts the numbers~\cite{Chattopadhyay} and sends it to
a debitation system to make effective the toll payment, similar to the
case of RFID but the detection system. This approach is often called
\emph{Automatic license plate recognition} (ALPR)~\cite{ALPR_mercosur}.

One of the most popular traffic tolling companies cited
by~\cite{Chattopadhyay} is Raytheon Technologies~\cite{Raytheon},
whose tolling systems are based on cameras and in-road induction
detectors. The cameras help to capture the car license plates and the
induction sensors help the system trigger the cameras. This
adds complexity to the system and makes the set up complicated,
levering the system installation cost. Based on that, this paper will
focus on the ALPR approach.

The challenges associated to ALPR systems from the computer vision
point-of-view are:

\begin{itemize}
	\item Motion blur because of car displacement.
	\item Poor illumination or low contrast due to reflections, shadows.
	\item Reliability of the detection.
	\item Rotation and traslation of the license plate.
	\item Circumvention techniques.
	\item Variety of license plates and vehicles.
\end{itemize}

Some of those problems have been addressed for several years in Computer
Vision. With Deep Learning techniques, the reliability of the detections
has increased over the years.

%------------------------------- RELATED WORK --------------------------------%
\section{Background and related work}
\label{sec:relatedwork}

ALPR has been addressed from several techniques, from traditional
image processing techniques such as binarization, Sobel filtering and
morphological operations to machine learning based approaches to find
the license plate and highlight the digits. Examples of this approach
can be found in~\cite{Lin2019} and~\cite{Aung2019}, by focusing on
speed rather than accuracy. According to~\cite{Zhang2018}, these
methods report error rates close to $23.9\%$ which may be not proper
for this application.

In the classical machine learning approach, multi-feature techniques
combined with cascade detectors have given promising
results. In~\cite{Zhang2018}, the authors present a fast multi-feature approach,
which gives results in $17\ ms$ with an error rate of
$3.8\%$. Contrasted to other methods like the traditional image
processing with $9.6\ ms$ and AdaBoost, which takes $22.2\ ms$ and
offer an error rate of $22\ ms$.

The problem has been addressed by using state-of-the-art deep learning
methods. The authors in~\cite{Chattopadhyay} propose a system to
detect the vehicles to replace the induction car detectors by using
\emph{You Only Look Once} (YOLO) version 4, getting $98\%$ of accuracy
taking $27.34\ ms$ for inference. Addressed the problem of detecting
the license plate under several adverse conditions such as rotation,
blur and poor illumination is addressed in~\cite{ALPR_mercosur}. For
this task,~\cite{ALPR_mercosur} uses YOLO version 3 achieving a
$95.53\%$ of accuracy and an inference time of $0.12\ ms$ on CPU. A
similar problem is also addressed by~\cite{Lin2019_mrcnn}, using
Mask-RCNN to tackle the problem, having $99\%$ of accuracy but a
processing time greater than one second.

\subsection{Datasets}
\label{subsec:dataset}

A large quantity of good quality data is the essential for any machine
learning system, this is especially true for neural networks.
% \todo{citation}

Often one of the most expensive tasks when training a neural network
model is to label the
data. In~\ref{subsubsec:license-plate-dataset}
and~\ref{subsubsec:Letters/Numbers} pre-labeled datasets are
identified.

\subsubsection{License Plate}
\label{subsubsec:license-plate-dataset}

The Peking University Dataset~\cite{yuan2016robust} it consists of
3977 images captured under diverse conditions.

\subsubsection{Letters/Numbers}
\label{subsubsec:Letters/Numbers}

The Chars74k~\cite{chars74k} is a dataset with English and Kannada
digits. Within the English, there are some computer fonts and it contains
both capital and lowercase letters and digits, uniformly distributed among
74000 samples.

Character classification data for license plates~\cite{Rawat2016} has 36
classes and 12757 images extracted from plate images split into training and
testing sets.

\subsection{Deep Learning State-of-the-Art}
\label{subsec:state-of-the-art}

Deep learning methods have for the last few years been the best
performing method in detection tasks.

Deep learning methods have for the last few years been the best
performing method in detection tasks. These can be divided among two
families. The Regions with Convolutional Neural Networks (R-CNN)
family~\cite{girshick2015fast} is a two-stage
network, the first stage is a region proposal region, then a second
stage task is to classify these proposals into actual detections.

The second of these families are one-stage detector, of which the
YOLO~\cite{redmon2016you} models are the most prominent
examples. Although, their accuracy is worse than the two-stage
detectors, they have a much lower inference time and smaller model
size.

\begin{table}[htbp]
	\begin{tabular}{|l|r|r|r|}
		\hline
		\textbf{Network} & \multicolumn{1}{l|}{\textbf{$AP_M$ in MS COCO}} & \multicolumn{1}{l|}{\textbf{FPS}} & \multicolumn{1}{l|}{\textbf{Model Size}(MB)} \\ \hline
		Yolov4           & 44.4                                            & 38                                & 416                                          \\ \hline
		Yolov3           & 30.6                                            & 45                                & 320                                          \\ \hline
		LRF              & 34.9                                            & \textbf{76.9}                     & 300                                          \\ \hline
		SSD              & 25.9                                            & 43                                & 300                                          \\ \hline
		RefineDet        & 32.0                                            & 38.7                              & 320                                          \\ \hline
		M2Det            & 37.6                                            & 33.4                              & 320                                          \\ \hline
		PFPNet           & 35.5                                            & 33                                & 320                                          \\ \hline
		RetinaNet        & 35.8                                            & 13.9                              & 500                                          \\ \hline
		FSAF             & 44.2                                            & 5.6                               & 800                                          \\ \hline
		CornerNet        & \textbf{44.8}                                   & 4.4                               & 512                                          \\ \hline
	\end{tabular}
	\caption{Accuracy on the COCO dataset, FPS reported on a Maxwell architecture and Model Size}
	\label{tab:accuracy}
\end{table}

The values reported in the Table~\ref{tab:accuracy} are for servers
using the same architecture as the Jetson Nano, but since these have a
much higher computational power. Using the same network as is will
have a reduced FPS, but as seen in the table there is a correlation
between inference speed and accuracy. More details about the
capabilities of the Jetson Nano can be found on
Section~\ref{subsec:jetson-nano}.

\subsection{Metrics}
\label{subsec:metrics}

In object detection tasks traditional metrics such as accuracy and
recall cannot be used directly since in these tasks the amount of
true negatives is going to be much larger than the amount of other
parameters. Other considerations such as how displaced is a detection
box from the ground truth must be taken into account before
classifying it as a true positive~\cite{padillaCITE2020}.

The more commonly used metrics come from competition benchmarks, these
define an algorithm (and occasionally an actual implementation of
this). The ones used by state of art algorithm are:

\begin{itemize}
	\item \textbf{PASCAL VOC Challenge}~\cite{everingham2010pascal} offers
	      a Matlab script in order to evaluate the quality of the detected
	      objects. The current
	      metrics used by the current PASCAL VOC object detection challenge
	      are the Precision x Recall curve and Average Precision.
	\item \textbf{COCO Detection Challenge}~\cite{lin2014microsoft} uses different metrics to evaluate the
	      accuracy of object detection of different algorithms. This
	      competition offers Python and Matlab codes so users can verify their
	      scores.
	\item \textbf{Google Open Images Dataset V4
		      Competition}~\cite{kuznetsova2018open} also uses mean Average
	      Precision (mAP) over the 500 classes to evaluate the object
	      detection task.
\end{itemize}

All of these metrics are based on the following two concepts:

\subsubsection{Intersection over the Union}
\label{subsubsec:IoU}

The concept of intersection over the union can be seen on
figure~\ref{fig:iou}. This is the percentage of the image that is
intersecting of the ground truth and the predicted box, the boxes on
the left have an IoU of around $50\%$ while the second has an IoU of
around $25\%$.

\begin{figure}
	\begin{tikzpicture}
		\draw[draw=black, fill=blue] (0,0) rectangle ++(1.5,1.5);
		\draw[draw=black, fill=red] (0.5,-0.5) rectangle ++(1.5, 1.5);
		\draw[draw=red, fill=purple] (0.5,0) rectangle ++(1, 1);

		\draw[draw=black, fill=blue] (3,0) rectangle ++(1.5,1.5);
		\draw[draw=black, fill=red] (4,-0.5) rectangle ++(1.5, 1.5);
		\draw[draw=red, fill=purple] (4,0) rectangle ++(0.5, 1);
	\end{tikzpicture}
	\caption{Intersection over the Union example}
	\label{fig:iou}
\end{figure}

\subsubsection{Recall vs Precision Curve}
\label{subsubsec:recall_vs_precision}

Generally precision and recall will have an inverse proportionallity
between them in detection as IoU threshold varies. For example 4
detections of a single object are considered as 1 correct detection
and 4 false detections.

\begin{figure}
	\begin{tikzpicture}
		\begin{axis}[
				xlabel={Recall},
				ylabel={Precission},
				xmin=0, xmax=1,
				ymin=-0.1, ymax=1.1,
				ymajorgrids=true,
				grid style=dashed,
			]

			\addplot[
				color=blue,
				mark=square,
			]
			coordinates {
					(0.0660, 1)
					(0.0666, 0.5)
					(0.1333, 0.666)
					(0.1333, 0.5)
					(0.1333, 0.4)
					(0.1333, 0.333)
					(0.1333, 0.2875)
					(0.1333, 0.25)
					(0.1333, 0.2222)
					(0.2000, 0.3)
					(0.2000, 0.2727)
					(0.2666, 0.3333)
					(0.4000, 0.4285)
					(0.4000, 0.4)
					(0.4000, 0.375)
					(0.4000, 0.3529)
					(0.4000, 0.3333)
					(0.4000, 0.3157)
					(0.4000, 0.3)
					(0.4000, 0.2857)
					(0.4000, 0.2727)
					(0.4666, 0.3043)
					(0.4666, 0.2916)
				}; \addlegendentry{Real Data}

			\addplot[
				color=red,
				mark=circle,
			]
			coordinates {
					(0, 1)
					(0.0666, 1)
					(0.0666, 0.6666)
					(0.1333, 0.6666)
					(0.1333, 0.4285)
					(0.4000, 0.4285)
					(0.4000, 0.3043)
					(0.4666, 0.3043)
					(0.4666, 0)
					(1.000, 0)
				}; \addlegendentry{Interpolated Curve}

		\end{axis}
	\end{tikzpicture}
	\caption{Precision vs Recall Curve}
	\label{fig:precision_recall}
\end{figure}

Figure~\ref{fig:precision_recall} shows the precision vs recall
curve. For all values these are ploted against each other and a
segmented degree 0 interpolation curve is determined, the area under
this curve is used to determine the median average precission $mAP$.
These are regularly obtained for several IoU values so its common
to see $mAP_{50}$ for an intersection of $50\%$, if more than one
IoU values are used all of these are averaged in $mAP_m$.

\subsection{Platform characteristics}
\label{subsec:jetson-nano}

% -- Brief intro -- %

The platform to utilize during the work will be the NVIDIA Jetson
Nano, given its capabilities and power consumption. This platform is
based on a System on Module (SoM) equipped with a Graphics Processing
Unit (GPU), an ARM-based General Purpose Central Processing Unit
(GPCPU), and some hard cores specialised in image processing,
especially video encoding and decoding~\cite{JetsonNanoSpecs}.

% -- Resources -- %

Deeping into the computation power details, the GPCPU is a quad-core
ARM-A57 processor running at 1.43 GHz equipped with FPU and
NEON~\cite{ARM-A57}.

Nonetheless, the real power of this SoM is found on its GPU, based on
a Maxwell architecture with 128 CUDA cores~\cite{JetsonNanoSpecs}
within a single Stream Multiprocessor (SM), allowing to schedule up to
32 threads per dispatchment ~\cite{NanoMaxwell}.

% -- Processing capabilities -- %

Unlike normal consumer user computers, the Jetson Nano centralizes the
memory, making it shared between the GPCPU and the GPU. This increases
the throughput and the bandwidth, since the penalty of memory
transfers are avoided~\cite{NanoMaxwell}. Besides that, the Jetson
Nano allows to use CUDA to speed up algorithms on GPU, allowing to
represent Fortran/C/C++ kernels.

The Jetson Nano has on-board 4GB of Low-Power Double Data Rate (LPDDR)
4 main memory, with a theoretical peak bandwidth of 25.6
GB/s~\cite{NanoMaxwell}.

% -- Deep learning -- %

For Deep Learning applications, there are some frameworks to combine
image analysis with Machine Learning tasks. NVIDIA comes with the
Deepstream SDK on its version 5.0 release as of August
3rd~\cite{Deepstream}, this SDK is closed-source.

RidgeRun offers GstInference, an open-source framework for
GStreamer. Its first release was on 2018 and it supports multiple
back-ends and devices thanks to an abstraction layer which makes the
implementation agnostic to the user~\cite{GstInference}.

Both frameworks implement a video stream pipeline, integrating
multiple Deep Learning processing in a daisy chain fashion. There are
some other common back-ends popular on the community, such as
TensorFlow, TensorRT and PyTorch, supported by the Jetson
Nano~\cite{ellinux}.

% -- Power Consumption -- %

Its power consumption is around 5W, making it suitable for
Internet-of-Things (IoT) applications, especially for those which
require a Deep Learning base, such as image analysis and
classification tasks.

% ------------------------------ REQUIREMENTS --------------------------------%
\section{Framework requirements}
\label{sec:requirements}

This project proposes an edge computing approach to address the
inference of the license plates number, lowering the loads of the
cloud computing centres and making them specialise to handle
requests. This will lower the cost and power consumption of the
computing resources in the cloud infrastructures. Edge
computing~\cite{edgesmartcities} proposes to off-load computation by
providing nodes some computational capabilities as a part of the Smart
Cities discussions.

With the purpose reducing the costs and exploiting the
state-of-the-art proposed in~\cite{Chattopadhyay}, the framework
should run on a NVIDIA Jetson Nano, given its cost and GPU
acceleration capabilities, making it as a proper candidate as a
computational unit in the edge.

The use case will consider the following assumptions:

\begin{itemize}
	\item The car reduces the speed enough to allow the system to
	      determine the license plate number similarly to the Costa Rican
	      traffic tolls.
	\item A camera is installed either in the ceiling or on the vehicle
	      barrier gate, close to the license plate.
	\item The plates are normalized in the passenger automobile license
	      plate format (see Figure~\ref{fig:crlicenceplate}).
	\item The license plate numbers are sent through TCP sockets through
	      the Internet.
	\item An NVIDIA Jetson Nano is available for experimentation.
\end{itemize}

\begin{figure}
	\centering
	\includegraphics[width=0.5\columnwidth]{img/cr_licence_plate.png}
	\caption{Passenger automobile license plate format}
	\label{fig:crlicenceplate}
\end{figure}

For the framework requirements, taking into account the assumptions made above:

\begin{itemize}
	\item The system shall fit in a NVIDIA Jetson Nano, and use acceleration
	\item The system shall send the license plate number through a network
	      connection.
\end{itemize}

% ------------------------------- PROPORSAL ---------------------------------%
\section{Proposed architecture}
\label{sec:proposal}

\begin{figure}
	\resizebox{\columnwidth}{!}{%
		\begin{tikzpicture}[%
				auto,
				block/.style={
						rectangle,
						draw=black,
						thick,
						fill=white,
						text width=5em,
						align=center,
						rounded corners,
						minimum height=2em
					},
				block1/.style={
						rectangle,
						draw=blue,
						thick,
						fill=blue!20,
						text width=5em,
						align=center,
						rounded corners,
						minimum height=2em
					},
				line/.style={
						draw,thick,
						-latex',
						shorten >=2pt
					},
				cloud/.style={
						draw=red,
						thick,
						ellipse,
						fill=red!20,
						minimum height=1em
					}
			]
			\filldraw[draw=black,fill=white] (0,0) rectangle (2,2);
			\draw (1,-1) node[block] (C) {Input Image};

			\draw[->] (2,1) -- (3,1);

			\filldraw[draw=black,fill=white] (3,0)     rectangle (5,2);
			\filldraw[draw=black,fill=white] (3.1,0.1) rectangle (5,2.1);
			\filldraw[draw=black,fill=white] (3.2,0.2) rectangle (5,2.2);
			\draw (4,-1) node[block] (C) {License Plate Detection Network};

			\draw[->] (5,1) -- (6,1);

			\filldraw[draw=black,fill=white] (6,0)     rectangle (8,2);
			\draw (7,-1) node[block] (C) {Character finder};

			\draw[->] (8,1) -- (9,1);

			\filldraw[draw=black,fill=white] (9,0)     rectangle (11,2);
			\filldraw[draw=black,fill=white] (9.1,0.1) rectangle (11,2.1);
			\filldraw[draw=black,fill=white] (9.2,0.2) rectangle (11,2.2);
			\draw (10,-1) node[block] (C) {Character Classification Network};
		\end{tikzpicture}
	}%
	\caption{High level system overview}
	\label{fig:system}
\end{figure}

The system will follow the general form shown in
Figure~\ref{fig:system}. It will receive an RGB image which will be
fed to a license plate detection network. Once the license plate ROI
is determined, the following stage will find the characters within the
ROI using morphological operations. The second network will receive
this cropped output based on the license plate detection and determine
the license plate number itself.

\subsection{license plate detection}
\label{subsec:licence_plate_detection}

\begin{table}[htbp]
	\begin{tabular}{c|c|c|c}
		\textbf{Type}       & \textbf{Filters} & \textbf{Size/Stride} & \textbf{Output} \\
		\hline
		Convolutional       & $128$            & $3\times3$           & $640\times320$  \\
		Convolutional       & $64$             & $3\times3$           & $640\times320$  \\
		Batch Normalization &                  &                      & $640\times320$  \\
		Maxpool             &                  & $2\times2/2$         & $320\times160$  \\
		Convolutional       & $128$            & $3\times3$           & $320\times160$  \\
		Convolutional       & $64$             & $3\times3$           & $320\times160$  \\
		Batch Normalization &                  &                      & $320\times160$  \\
		Maxpool             &                  & $2\times2/2$         & $160\times80$   \\
		Convolutional       & $256$            & $3\times3$           & $160\times80$   \\
		Convolutional       & $128$            & $3\times3$           & $160\times80$   \\
		Batch Normalization &                  &                      & $160\times80$   \\
		Maxpool             &                  & $2\times2/2$         & $80\times40$    \\
		Convolutional       & $256$            & $3\times3$           & $80\times40$    \\
		Convolutional       & $128$            & $3\times3$           & $80\times40$    \\
		Batch Normalization &                  &                      & $80\times40$    \\
		Maxpool             &                  & $2\times2/2$         & $40\times20$    \\
		Convolutional       & $128$            & $3\times3$           & $40\times20$    \\
		Convolutional       & $64$             & $3\times3$           & $40\times20$    \\
		Batch Normalization &                  &                      & $40\times20$    \\
		Maxpool             &                  & $2\times2/2$         & $20\times10$    \\
		Convolutional       & $128$            & $3\times3$           & $20\times10$    \\
		Convolutional       & $64$             & $3\times3$           & $20\times10$    \\
		Batch Normalization &                  &                      & $20\times10$    \\
		Maxpool             &                  & $2\times2/2$         & $10\times5$     \\
		Convolutional       & $128$            & $3\times3$           & $10\times5$     \\
		\hline
		\hline
		Convolutional       & $5$              & $3\times3$           & $10\times5$
	\end{tabular}
	\caption{License Plate detection network for an input of $640\times320$, all activation layers are LeakyRelu}
	\label{tab:license-detector-network}
\end{table}

On Table~\ref{tab:license-detector-network} the network architecture for the detection are shown. The last layer has 5 channels each of these represents:

\begin{itemize}
	\item Confidence
	\item Width Scaling
	\item Height Scaling
	\item Vertical Shift
	\item Horizontal Shift
\end{itemize}

These shifts and scaling are made based on a set of predefined boxes,
these are located equidistant, and the network predicts how much does
this box shifts, this is inspired by the work
on~\cite{redmon2017yolo9000}. Since the last layers has a resolution
of $10\times5$ which means that the network can detect up to $50$
boxes. The default boxes for thi case have a size of $64\times64$.

Note that this is a fully convolutional network, this means that the
input image size can be variable, without needing to retrain the
network. For this example a resolution of $640\times320$ is used since
its $2:1$ ratio is similar to the $16:9$ output of most cameras.

\subsection{Character detection}
\label{subsec:character_detection}

Given that there is a high contrast between the background and font
colors within the license plates (Figure~\ref{fig:crlicenceplate}),
it is possible to perform an image binarization, followed by
morphological operations and ROI look-ups by using cluster bounding
box drawing. This will save computational resources since heavier
convolutions are not performed onto the image.

The process of character detection is illustrated in
Figure~\ref{fig:character_detection}.

\begin{figure}[h]
	\resizebox{\columnwidth}{!}{%
		\begin{tikzpicture}[%
				auto,
				block/.style={
						rectangle,
						draw=black,
						thick,
						fill=white,
						text width=6em,
						align=center,
						rounded corners,
						minimum height=2em
					},
				block1/.style={
						rectangle,
						draw=blue,
						thick,
						fill=blue!20,
						text width=5em,
						align=center,
						rounded corners,
						minimum height=2em
					},
				line/.style={
						draw,thick,
						-latex',
						shorten >=2pt
					},
				cloud/.style={
						draw=red,
						thick,
						ellipse,
						fill=red!20,
						minimum height=1em
					}
			]
			\node[] (plate) at (0,1)
			{\includegraphics[width=4cm]{img/cr_licence_plate.png}};
			\draw (0,-1) node[block] (C) {Input Image};

			\draw[->] (2,1) -- (3,1);

			\node[] (preprocess) at (5,1)
			{\includegraphics[width=4cm]{img/cr_licence_plate_preproc.png}};
			\draw (5,-1) node[block] (C) {Preprocessing};

			\draw[->] (7,1) -- (8,1);

			\node[] (bbs) at (10,1)
			{\includegraphics[width=4cm]{img/cr_licence_plate_bbs.png}};
			\draw (10,-1) node[block] (C) {Bounding boxes};

		\end{tikzpicture}
	}%
	\caption{Character detection process}
	\label{fig:character_detection}
\end{figure}

\subsection{Character classification}
\label{subsec:character_classification}

\hyperref[subsec:character_detection]{Character detection} produces the ROI
for each character. By iterating over all the characters, it is possible to
classify each of them by a neural network and concatenate the predictions to
finally determine the license plate number.

Each character is extracted from the \emph{preprocessing} image produced in
~\hyperref[subsec:character_detection]{Character detection} (see
Figure~\ref{fig:character_detection}), since the background is set to a lower
value and the character is the highest value. This practice has been observed
in other character datasets such as MNIST and EMNIST~\cite{cohen2017emnist}.

For the classification, an adapted LeNet model~\cite{lenet} (see
Figure~\ref{fig:character_classification}) is used for multi-class
classification. The network is trained using the font Chars74k
dataset~\cite{chars74k} with 36 classes:

\begin{itemize}
	\item Capital letters: 26 classes
	\item Numerical digits: 10 classes
\end{itemize}

\begin{figure}[h]
	\centering
	\includegraphics[width=\columnwidth]{img/character_model.pdf}
	\caption{Character classification model. This model receives a binary
		image and classifies it within 36 classes}
	\label{fig:character_classification}
\end{figure}

After the classification task, the character is decoded and concatenated
within a string. Then, it is send through Transmission Control Protocol (TCP)
to a NodeJS script, which plays the role as the web server.

\subsection{Back-end}
\label{subsec:backend}

To represent the models, this project will make the most of PyTorch, given that it
is supported in the Jetson Nano, makes the most of the hardware acceleration
capabilities and there are bindings for Python. TensorFlow is also an option
and it can be used as well, carrying out the same benefits as PyTorch.
The deep learning framework will be recommended for future work.

% Some other more architecture specific ideas include:
% \begin{itemize}
% \item Probabily a tiny-yolov3 like, in that case we should be able to use transfer learning, from the darkenet convolutional.
% \item Encoder-Decoder
% \item Output is MxNxD where MxN is a grid and D is a vector with:
% \item likelihood, dx, dy, sx, sy
% \item and dx, dy, sx, sy are translations and scalings over a subset of predetermined boxes (This is the yolo output, state of the art might have modified this)
% \item Framework to use for training?
% \item Framework to use for inference?
% \end{itemize}

% ------------------------------ EVALUATION ---------------------------------%
\section{Evaluation}
\label{sec:evaluation}

\subsection{Execution Time}
\label{subsec:eval-time}

On Table~\ref{tab:exec-time} the execution time for the neural
networks on the system can be seen. The system is not able to run at a
real-time, since the license plate detection only runs up to $2\ fps$,
the character detection network is much faster, assumming a license
plate lenght of 6 characters this subsytem would run at a speed of
around $50\ fps$.

Not pictured in this table is the image loading time nor the time it
takes to move it to the GPU, and move the result of the network back
to the CPU. Further improvements to the system should include the
usage of Deepstream~\cite{Deepstream} or
GstInference~\cite{GstInference} to avoid this copies, this would also
allow for accelerated scaling to the input image size using the
available hardware elements.

An initial proposal of the system included a car detection as a
previous stage before the license plate detection. Since the car detection would have an architecture

\begin{table}[htbp]
	\begin{tabular}{l|c|}
		\cline{2-2}
		                                                            & \textbf{Inference Time (ms)} \\ \hline
		\multicolumn{1}{|l|}{License Plate Detector}                & 497.61                       \\ \hline
		\multicolumn{1}{|l|}{Character Recognition (per character)} & 3.71                         \\ \hline
	\end{tabular}
	\caption{Execution time for the license plate detector and the character recognition on a Jetson Nano}
	\label{tab:exec-time}
\end{table}

\subsection{License plate detection}
\label{subsec:eval-licence_plate_detection}

The license plate detection network was trained on the PKU license
plate dataset~\cite{yuan2016robust}, the images were split $80-20$
between the training and the testing datasets. Mean squared error was
used as a loss and an Adam optimizer, the training was stopped when
the training mAP had not improved during 10 epochs, each was split in
batches with a size of $128$. Different metrics measured during
training are shown on Figures~\ref{fig:lp-map},
\ref{fig:lp-precision}, \ref{fig:lp-recall}.

\begin{figure}[htbp]
	\begin{tikzpicture}
		\begin{axis}[
				ylabel=mAP,
				xlabel=Step,
				legend pos=south east,
				no markers
			]
			\addplot table [x=Step, y=Train mAP, col sep=comma] {data/license_plate_training.csv};

			\addplot table [x=Step, y=Test mAP, col sep=comma] {data/license_plate_training.csv};

			\addlegendentry{Train mAP}
			\addlegendentry{Test mAP}

		\end{axis}
	\end{tikzpicture}
	\caption{mAP with an IoU of 0.5 for license plate detection training and testing}
	\label{fig:lp-map}
\end{figure}

On Figure~\ref{fig:lp-map} the mAP for the training and the testing
are shown, the peak value for both training and training is about
$0.72$. However the map curve for the training has a much noisier
behaviour. This is also happens for both recall and precision. Since
the mAP is derived from the both of those values it is expected that
at least one of these is causing the behaviour.

Although on average the testing has lower values than the training, the
ascending behaviour is always kept for both. This shows the lack of
overfitting since if this was the case, the training would tapper off
at a certain value instead of having a continous rise.

\begin{figure}[htbp]
	\begin{tikzpicture}
		\begin{axis}[
				ylabel=Recall,
				xlabel=Step,
				legend pos=south east,
				no markers
			]
			\addplot table [x=Step, y=Train Recall, col sep=comma] {data/license_plate_training.csv};

			\addplot table [x=Step, y=Test Recall, col sep=comma] {data/license_plate_training.csv};

			\addlegendentry{Train Recall}
			\addlegendentry{Test Recall}

		\end{axis}
	\end{tikzpicture}
	\caption{Recall with an IoU of 0.5 for license plate detection training and testing}
	\label{fig:lp-recall}
\end{figure}

\begin{figure}[htbp]
	\begin{tikzpicture}
		\begin{axis}[
				ylabel=Precision,
				xlabel=Step,
				legend pos=south east,
				no markers
			]
			\addplot table [x=Step, y=Train Precision, col sep=comma] {data/license_plate_training.csv};

			\addplot table [x=Step, y=Test Precision, col sep=comma] {data/license_plate_training.csv};

			\addlegendentry{Train Precision}
			\addlegendentry{Test Precision}

		\end{axis}
	\end{tikzpicture}
	\caption{Precision with an IoU of 0.5 for license plate detection training and testing}
	\label{fig:lp-precision}
\end{figure}

On figures~\ref{fig:lp-precision} and~\ref{fig:lp-precision} the
recall and precision values during the training can be seen. Recall
reaches a value maximum value of around $0.8$ while the precision
reaches a $0.83$.

Modifying the IoU threshold determined for a specific will skew the
results to either the precision or the recall. Since the number plate
will be processed by a further step in the character recognition, a
bias towards the recall can be a good thing since ideally all
plates are selected; while a lower precision can be tolerated since
incorrect characters or other anomalies can be removed during this
step.

\subsection{Character classification}
\label{subsec:character-classification-res}

The training of the character classification network
(Figure~\ref{fig:character_classification} used the configuration
presented in Table~\ref{tab:chars-configurations}, running 10 epochs each.

\begin{table}[htpb]
	\begin{tabular}{|l|c|c|c|}
		\hline
		\textbf{Name} & \textbf{Batch Size} & \textbf{Learning Rate} & \textbf{Dataset} \\ \hline
		Chars74\_Def  & 100                 & 0.001                  & Chars74          \\ \hline
		Chars74\_BS50 & 50                  & 0.001                  & Chars74          \\ \hline
		Chars74\_LR-4 & 100                 & 0.0001                 & Chars74          \\ \hline
		Emnist        & 100                 & 0.0001                 & EMNIST           \\ \hline
	\end{tabular}
	\caption{Hyper-parameter configurations for the character classification network}
	\label{tab:chars-configurations}
\end{table}

For the training and testing set, both came from the \emph{Chars74k} dataset,
since the number of license plate samples are limited and unlabeled. The
distribution of the samples were 27432 for training and 9144 for testing.

Those configurations led to the training results presented in
Table~\ref{tab:chars-training} and~\ref{tab:chars-testing}. From the several
configurations tested during the training, the \emph{Chars74\_BS50} was the
best in terms of the metrics, achieving the highest accuracy. Evaluating the
overfitting from the tables, the gap among the metrics for both the training
and testing stage is less than in the other examined configurations.

\begin{table}[htpb]
	\begin{tabular}{|l|c|c|c|c|}
		\hline
		\textbf{Configuration} & \textbf{Acc} & \textbf{Loss} & \textbf{Prec} & \textbf{Recall} \\ \hline
		Chars74\_Def           & 0.98191      & 0.98213       & 0.98191       & 0.98414         \\ \hline
		Chars74\_BS50          & 0.98516      & 0.00081       & 0.98540       & 0.98516         \\ \hline
		Chars74\_LR-4          & 0.91786      & 0.00287       & 0.91804       & 0.91786         \\ \hline
		Emnist                 & 0.75534      & 0.00770       & 0.75477       & 0.75534         \\ \hline
	\end{tabular}
	\caption{Character classification network training results for the training stage}
	\label{tab:chars-training}
\end{table}

\begin{table}[htpb]
	\begin{tabular}{|l|c|c|c|c|}
		\hline
		\textbf{Configuration} & \textbf{Acc} & \textbf{Loss} & \textbf{Prec} & \textbf{Recall} \\ \hline
		Chars74\_Def           & 0.97090      & 0.97123       & 0.97090       & 0.99038         \\ \hline
		Chars74\_BS50          & 0.97265      & 0.08038       & 0.97300       & 0.97265         \\ \hline
		Chars74\_LR-4          & 0.92946      & 0.25002       & 0.93030       & 0.92946         \\ \hline
		Emnist                 & 0.84628      & 0.43467       & 0.85566       & 0.84628         \\ \hline
	\end{tabular}
	\caption{Character classification network training results for the testing stage}
	\label{tab:chars-testing}
\end{table}

Figure~\ref{fig:classification-examples-standalone} presents some results on
real Costa Rican license plates. Most of the plates were detected properly even
when they did not meet the standard assumed by this framework (see
Figure~\ref{subfig:class-eighth}). There are also some mispredictions when
dealing with zeros, which are mispredicted as "O"s, like in the case of
Figure~\ref{subfig:class-sixth}.

\subsection{Qualitative Results}
\label{subsec:qualitative-results}

On figure~\ref{fig:detections-examples} sample detections and
classifications are shown. The first detection stage can detect several plates, each of these is cropped and passed to the classification stage

The bounding box given by the detection stage is enlarged such that there
is a better chance for the full character to be classified even when the 
detection stage does not have a complete overlap, the
complete license is passed to the classification.

\begin{figure*}[htpb]
	\begin{subfigure}{.18\textwidth}
		\centering
		\includegraphics[width=\linewidth]{detected_plate_0.png}
		\caption{Detection for a taxi}
		\label{subfig:det-first}
	\end{subfigure}
	\begin{subfigure}{.18\textwidth}
		\centering
		\includegraphics[width=\linewidth]{detected_plate_1.png}
		\caption{Detection for a car at night}
		\label{subfig:det-second}
	\end{subfigure}
	\begin{subfigure}{.18\textwidth}
		\centering
		\includegraphics[width=\linewidth]{detected_plate_2.png}
		\caption{Detection for a car}
		\label{subfig:det-third}
	\end{subfigure}
	\begin{subfigure}{.18\textwidth}
		\centering
		\includegraphics[width=\linewidth]{detected_plate_4.png}
		\caption{Detection for a van}
		\label{subfig:det-fourth}
	\end{subfigure}
	\begin{subfigure}{.18\textwidth}
		\centering
		\includegraphics[width=\linewidth]{detected_plate_5.png}
		\caption{Detection for a car at night}
		\label{subfig:det-fifth}
	\end{subfigure}
	\caption{Example Detections}
	\label{fig:detections-examples}
\end{figure*}

Figure~\ref{fig:detections-examples} shows example detections for
different vehicles on different scenarios. These include both day and
night detections. Not all detections match the license plate bounding
box, which can be seen represented as a blue box on the image. The
extracted box is enlarged and shown on
Figure~\ref{fig:classification-examples}.

\begin{figure*}[htpb]
	\begin{subfigure}{.18\textwidth}
		\centering
		\includegraphics[width=\linewidth]{license_plate_0.png}
		\caption{Detected Plate for plate on Figure~\ref{subfig:det-first}: GT222P}
		\label{subfig:class-first}
	\end{subfigure}
	\begin{subfigure}{.18\textwidth}
		\centering
		\includegraphics[width=\linewidth]{license_plate_1.png}
		\caption{Detected Plate for plate on Figure~\ref{subfig:det-second}: G98198}
		\label{subfig:class-second}
	\end{subfigure}
	\begin{subfigure}{.18\textwidth}
		\centering
		\includegraphics[width=\linewidth]{license_plate_2.png}
		\caption{Detected Plate for plate on Figure~\ref{subfig:det-third}: G9OS47}
		\label{subfig:class-third}
	\end{subfigure}
	\begin{subfigure}{.18\textwidth}
		\centering
		\includegraphics[width=\linewidth]{license_plate_4.png}
		\caption{Detected Plate for plate on Figure~\ref{subfig:det-fourth}: G963O6}
		\label{subfig:class-fourth}
	\end{subfigure}
	\begin{subfigure}{.18\textwidth}
		\centering
		\includegraphics[width=\linewidth]{license_plate_5.png}
		\caption{Detected Plate for plate on Figure~\ref{subfig:det-fifth}: G9OJ22}
		\label{subfig:class-fifth}
	\end{subfigure}
	\caption{Example Classifications}
	\label{fig:classification-examples}
\end{figure*}

\begin{figure*}[htpb]
	\centering
	\begin{subfigure}{.18\textwidth}
		\centering
		\includegraphics[width=\linewidth]{licence_plate_6.png}
		\caption{Detected Plate: 12O495}
		\label{subfig:class-sixth}
	\end{subfigure}
	\begin{subfigure}{.18\textwidth}
		\centering
		\includegraphics[width=\linewidth]{licence_plate_7.jpg}
		\caption{Detected Plate: 717127}
		\label{subfig:class-seventh}
	\end{subfigure}
	\begin{subfigure}{.18\textwidth}
		\centering
		\includegraphics[width=\linewidth]{licence_plate_8.jpg}
		\caption{Detected Plate: 6499}
		\label{subfig:class-eighth}
	\end{subfigure}
	\begin{subfigure}{.18\textwidth}
		\centering
		\includegraphics[width=\linewidth]{licence_plate_9.png}
		\caption{Detected Plate: BBF932}
		\label{subfig:class-nineth}
	\end{subfigure}
	\caption{Example classifications for standalone license plates}
	\label{fig:classification-examples-standalone}
\end{figure*}

For each license plate the extracted plates number can be seen on
Figure~\ref{fig:classification-examples}. On
Figure~\ref{subfig:class-first} the number $4$ and the number $9$ are
miss-classified, the number 4 is most likely misclassified since the
bounding box crops part of the image.

All characters on Figure~\ref{subfig:class-second} are classified
correctly. But on Figure~\ref{subfig:class-third} both the $0$ and the
$5$ are missclassified as an $O$ and an $S$, since these characters
are too similar. This can be fixed by enlarging the dataset or adding
images closer to the license plates.

On both Figure~\ref{subfig:class-fourth} and
Figure~\ref{subfig:class-fifth} the $1$ is misclassified. Since the
implemented algorithm gets the bounding box for a given ``blob'' and
expanded to a resolution of $28\times28$ this can end up as an blob
which occupies the whole image resulting in the
misclassification. Note that the $1$ in
Figure~\ref{subfig:class-second} is correctly classified.

Plates normally follow a given format for examples Costa Rica plates
as shown on figure~\ref{fig:crlicenceplate} have three numbers
followed by three letters. This means that instead of a general character
classification network, two networks could be used for letters and numbers.

Although not shown, the Chinese character is in all cases misclassified
as one of the 26 letters of the alphabet or a number, ideally the
network should be able to also correctly classify the character.

% ------------------------------- CONCLUSIONS --------------------------------%
\section{Conclusions and Future Work}
\label{sec:conclusions}

The system is able to succesfully detect and classify the characters
from license plates. These classifications are succesfull under most
cases where there is no ambiguity between letters and numbers, since
normally license plates follow a given format these could be solved by
dividing the classification into letters and numbers following the
format.

Although the system is unable to run at real-time its performance of
$2\ fps$ is enough for most parking and tolling systems. This
performance can be further enchanced by the usage of libraries such as
TensorRT or more general frameworks such as DeepStream or
GstInference. Other improvements such as moving to a fixed point
implementation or using prunning to reduce the networks size can also
be considered to speed up its performance.

The system reaches an mAP of $72\%$ for license plate detection and an
accuracy of $99\%$ for the character classification. The detection
network, however, might show a bias towards the license plate dataset
which contains exclusively Chinese plates.

%------------------------------- REFERENCES ---------------------------------%
%\newpage
% references section
\bibliography{autosystems}
\bibliographystyle{IEEEtran}

% that's all folks
\end{document}
